unit Debub;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Models, ExtCtrls, OpenGL;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ViewModel:TModel;
  Form1: TForm1;
  DC:HDC;
  HRC:HGLRC;
  tex:pByteArray;
  TW, TH:Integer;
  FPS:integer;  {Frames per second}
  Speed:Double;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  Bi:TBitmap;
  nPixelFormat: Integer;
  pfd: TPixelFormatDescriptor;
  i, j:integer;
begin
  ViewModel:=TModel.Create;
  ViewModel.LoadFromFile('1.yem');
  Bi:=TBitmap.Create;
  Bi.LoadFromFile('g2.bmp');
  TW:=Bi.Width;
  TH:=Bi.Height;
  GetMem(tex,TW*TH*3);
  for j := 0 to TH - 1 do begin
    for i := 0 to TW - 1 do begin
      Tex[(j*TW + i)*3] := GetRValue(Bi.Canvas.Pixels[i,j]);
      Tex[(j*TW + i)*3+1] := GetGValue(Bi.Canvas.Pixels[i,j]);
      Tex[(j*TW + i)*3+2] := GetBValue(Bi.Canvas.Pixels[i,j]);
    end;
  end;
  Bi.Free;
  DC:=GetDC(form1.Handle);
  FillChar(pfd, SizeOf(pfd), 0);
  pfd.dwFlags := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
  nPixelFormat := ChoosePixelFormat(DC, @pfd);
  SetPixelFormat(DC, nPixelFormat, @pfd);
  hrc := wglCreateContext(DC);
  wglMakeCurrent(DC, hrc);
  glClearColor (0, 0, 0, 0);
  glEnable(GL_DEPTH_TEST);
  glEnable (GL_COLOR_MATERIAL);
  glEnable (GL_NORMALIZE);
  glColor3f (0.4, 0.6, 0.6);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(20.0, 1.5, 1.0, 10000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  ViewModel.CurrentActions[0]:=0;
  ViewModel.CurrentActions[1]:=0;
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,TW,TH,0,GL_RGB,GL_UNSIGNED_BYTE,Tex);
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
  glEnable(GL_TEXTURE_2D);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
i:integer;
ps:TPaintStruct;
begin
  Timer1.Enabled:=false;
  FPS:=FPS+1;
  if ViewModel.TimeLeft<100 then begin
    ViewModel.CurrentActions[0]:=3;
    if ViewModel.CurrentActions[1]<2 then begin
      ViewModel.CurrentActions[1]:=ViewModel.CurrentActions[1]+1;
      ViewModel.Timers[1]:=0;
    end;
  end;
  BeginPaint(Handle, ps);
    glEnable(Gl_Texture_2d);
    glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
    glPushMatrix;
    gluLookat(5, -5, 1, 0, 1, 1,0,0,1);
    ViewModel.PresetRotateAngles(Round(5/Speed));
    ViewModel.DrawModel(0, 0, 1, 1);
    glPopMatrix;
    SwapBuffers (DC);
  EndPaint(Handle, ps);
  Timer1.Enabled:=true;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  Timer1.Enabled:=true;
  ViewModel.CurrentActions[0]:=0;
  ViewModel.CurrentActions[1]:=0;
  ViewModel.Timers[0]:=0;
  ViewModel.Timers[1]:=0;
  Speed:=0.15;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
s:string;
begin
  Speed:=FPS/200;
  Str(FPS, s);
  Form1.Caption:=s+' FPS';
  FPS:=0;
end;

end.
